#####################################################################
#
#       Copyright : Roshan Kumar Singh <singh.roshan08@gmail.com>
#       Licenced under GPLv2 or later.
#       Copyright: See License file that comes with this distribution
#
#####################################################################

import gtk, pango

class TextBuf(gtk.TextBuffer):
	def __init__(self, *args, **kwargs):
		gtk.TextBuffer.__init__(self, *args)
		
		self.text = ''		
		# Connect signals.
		#self.connect('insert_text',       self._on_insert_text)
		#self.connect('delete_range',      self._on_delete_range)
		#self.connect('apply-tag',         self._on_apply_tag)
		#self.connect('remove_tag',        self._on_remove_tag)

		# Create text styles.
		self.create_tag('bold',      weight    = pango.WEIGHT_BOLD, editable = 'True') 
		self.create_tag('italic',    style     = pango.STYLE_ITALIC)
		self.create_tag('underline', foreground = 'blue', underline = pango.UNDERLINE_SINGLE)
		self.create_tag('invisible', invisible = 'True')
		#self.link_style = dict(foreground = 'blue', underline  = pango.UNDERLINE_SINGLE)
	
	def apply_tag(self, tagname, start, end):
		#start, end = self.get_selection_bounds()
		self.apply_tag_by_name(tagname, start, end)

	def parse(self):
		iter = self.get_start_iter()
		start_tag = iter.forward_search('<b>', gtk.TEXT_SEARCH_VISIBLE_ONLY)
		while start_tag != None:		
			end_tag = iter.forward_search('</b>', gtk.TEXT_SEARCH_VISIBLE_ONLY)
			self.apply_tag('bold', start_tag[0], end_tag[0])
			self.apply_tag('invisible', start_tag[0], start_tag[1])
			self.apply_tag('invisible', end_tag[0], end_tag[1])
			start_tag = iter.forward_search('<b>', gtk.TEXT_SEARCH_VISIBLE_ONLY)

		iter = self.get_start_iter()
		start_tag = iter.forward_search('<i>', gtk.TEXT_SEARCH_VISIBLE_ONLY)
		while start_tag != None:		
			end_tag = iter.forward_search('</i>', gtk.TEXT_SEARCH_VISIBLE_ONLY)
			self.apply_tag('italic', start_tag[0], end_tag[0])
			self.apply_tag('invisible', start_tag[0], start_tag[1])
			self.apply_tag('invisible', end_tag[0], end_tag[1])
			start_tag = iter.forward_search('<i>', gtk.TEXT_SEARCH_VISIBLE_ONLY)

		iter = self.get_start_iter()
		start_tag = iter.forward_search('<a href', gtk.TEXT_SEARCH_VISIBLE_ONLY)
		while start_tag != None:
			start_tag_end = iter.forward_search('>', gtk.TEXT_SEARCH_VISIBLE_ONLY)		
			end_tag = iter.forward_search('</a>', gtk.TEXT_SEARCH_VISIBLE_ONLY)
			self.apply_tag('underline', start_tag[0], end_tag[0])
			self.apply_tag('invisible', start_tag[0], start_tag_end[1])
			self.apply_tag('invisible', end_tag[0], end_tag[1])
			start_tag = iter.forward_search('<a href', gtk.TEXT_SEARCH_VISIBLE_ONLY)

	def restore_text(self):
		'''Restores the text in the buffer with the stored text'''
		self.remove_all_tags(self.get_start_iter(), self.get_end_iter())
